/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     H_NUMBER = 258,
     D_NUMBER = 259,
     O_NUMBER = 260,
     B_NUMBER = 261,
     CONVERT_OP = 262,
     B_DATA = 263,
     H_RANGE_GUESS = 264,
     D_NUMBER_GUESS = 265,
     O_NUMBER_GUESS = 266,
     B_NUMBER_GUESS = 267,
     BAD_CMD = 268,
     MEM_OP = 269,
     IF = 270,
     MEM_COMP = 271,
     MEM_DISK8 = 272,
     MEM_DISK9 = 273,
     MEM_DISK10 = 274,
     MEM_DISK11 = 275,
     REG_ASGN_SEP = 276,
     EQUALS = 277,
     TRAIL = 278,
     CMD_SEP = 279,
     CMD_SIDEFX = 280,
     CMD_RETURN = 281,
     CMD_BLOCK_READ = 282,
     CMD_BLOCK_WRITE = 283,
     CMD_UP = 284,
     CMD_DOWN = 285,
     CMD_LOAD = 286,
     CMD_SAVE = 287,
     CMD_VERIFY = 288,
     CMD_IGNORE = 289,
     CMD_HUNT = 290,
     CMD_FILL = 291,
     CMD_MOVE = 292,
     CMD_GOTO = 293,
     CMD_REGISTERS = 294,
     CMD_READSPACE = 295,
     CMD_WRITESPACE = 296,
     CMD_RADIX = 297,
     CMD_MEM_DISPLAY = 298,
     CMD_BREAK = 299,
     CMD_TRACE = 300,
     CMD_IO = 301,
     CMD_BRMON = 302,
     CMD_COMPARE = 303,
     CMD_DUMP = 304,
     CMD_UNDUMP = 305,
     CMD_EXIT = 306,
     CMD_DELETE = 307,
     CMD_CONDITION = 308,
     CMD_COMMAND = 309,
     CMD_ASSEMBLE = 310,
     CMD_DISASSEMBLE = 311,
     CMD_NEXT = 312,
     CMD_STEP = 313,
     CMD_PRINT = 314,
     CMD_DEVICE = 315,
     CMD_HELP = 316,
     CMD_WATCH = 317,
     CMD_DISK = 318,
     CMD_SYSTEM = 319,
     CMD_QUIT = 320,
     CMD_CHDIR = 321,
     CMD_BANK = 322,
     CMD_LOAD_LABELS = 323,
     CMD_SAVE_LABELS = 324,
     CMD_ADD_LABEL = 325,
     CMD_DEL_LABEL = 326,
     CMD_SHOW_LABELS = 327,
     CMD_RECORD = 328,
     CMD_STOP = 329,
     CMD_PLAYBACK = 330,
     CMD_CHAR_DISPLAY = 331,
     CMD_SPRITE_DISPLAY = 332,
     CMD_TEXT_DISPLAY = 333,
     CMD_SCREENCODE_DISPLAY = 334,
     CMD_ENTER_DATA = 335,
     CMD_ENTER_BIN_DATA = 336,
     CMD_KEYBUF = 337,
     CMD_BLOAD = 338,
     CMD_BSAVE = 339,
     CMD_SCREEN = 340,
     CMD_UNTIL = 341,
     CMD_CPU = 342,
     CMD_BACKTRACE = 343,
     CMD_CPUHISTORY = 344,
     CMD_MEMMAPZAP = 345,
     CMD_MEMMAPSHOW = 346,
     CMD_MEMMAPSAVE = 347,
     CMD_SCREENSHOT = 348,
     CMD_PWD = 349,
     CMD_DIR = 350,
     CMD_RESOURCE_GET = 351,
     CMD_RESOURCE_SET = 352,
     CMD_ATTACH = 353,
     CMD_DETACH = 354,
     CMD_RESET = 355,
     CMD_TAPECTRL = 356,
     CMD_CARTFREEZE = 357,
     L_PAREN = 358,
     R_PAREN = 359,
     ARG_IMMEDIATE = 360,
     REG_A = 361,
     REG_X = 362,
     REG_Y = 363,
     COMMA = 364,
     INST_SEP = 365,
     REG_B = 366,
     REG_C = 367,
     REG_D = 368,
     REG_E = 369,
     REG_H = 370,
     REG_L = 371,
     REG_AF = 372,
     REG_BC = 373,
     REG_DE = 374,
     REG_HL = 375,
     REG_IX = 376,
     REG_IY = 377,
     REG_SP = 378,
     REG_IXH = 379,
     REG_IXL = 380,
     REG_IYH = 381,
     REG_IYL = 382,
     STRING = 383,
     FILENAME = 384,
     R_O_L = 385,
     OPCODE = 386,
     LABEL = 387,
     BANKNAME = 388,
     CPUTYPE = 389,
     REGISTER = 390,
     COMPARE_OP = 391,
     RADIX_TYPE = 392,
     INPUT_SPEC = 393,
     CMD_CHECKPT_ON = 394,
     CMD_CHECKPT_OFF = 395,
     TOGGLE = 396,
     MASK = 397
   };
#endif
#define H_NUMBER 258
#define D_NUMBER 259
#define O_NUMBER 260
#define B_NUMBER 261
#define CONVERT_OP 262
#define B_DATA 263
#define H_RANGE_GUESS 264
#define D_NUMBER_GUESS 265
#define O_NUMBER_GUESS 266
#define B_NUMBER_GUESS 267
#define BAD_CMD 268
#define MEM_OP 269
#define IF 270
#define MEM_COMP 271
#define MEM_DISK8 272
#define MEM_DISK9 273
#define MEM_DISK10 274
#define MEM_DISK11 275
#define REG_ASGN_SEP 276
#define EQUALS 277
#define TRAIL 278
#define CMD_SEP 279
#define CMD_SIDEFX 280
#define CMD_RETURN 281
#define CMD_BLOCK_READ 282
#define CMD_BLOCK_WRITE 283
#define CMD_UP 284
#define CMD_DOWN 285
#define CMD_LOAD 286
#define CMD_SAVE 287
#define CMD_VERIFY 288
#define CMD_IGNORE 289
#define CMD_HUNT 290
#define CMD_FILL 291
#define CMD_MOVE 292
#define CMD_GOTO 293
#define CMD_REGISTERS 294
#define CMD_READSPACE 295
#define CMD_WRITESPACE 296
#define CMD_RADIX 297
#define CMD_MEM_DISPLAY 298
#define CMD_BREAK 299
#define CMD_TRACE 300
#define CMD_IO 301
#define CMD_BRMON 302
#define CMD_COMPARE 303
#define CMD_DUMP 304
#define CMD_UNDUMP 305
#define CMD_EXIT 306
#define CMD_DELETE 307
#define CMD_CONDITION 308
#define CMD_COMMAND 309
#define CMD_ASSEMBLE 310
#define CMD_DISASSEMBLE 311
#define CMD_NEXT 312
#define CMD_STEP 313
#define CMD_PRINT 314
#define CMD_DEVICE 315
#define CMD_HELP 316
#define CMD_WATCH 317
#define CMD_DISK 318
#define CMD_SYSTEM 319
#define CMD_QUIT 320
#define CMD_CHDIR 321
#define CMD_BANK 322
#define CMD_LOAD_LABELS 323
#define CMD_SAVE_LABELS 324
#define CMD_ADD_LABEL 325
#define CMD_DEL_LABEL 326
#define CMD_SHOW_LABELS 327
#define CMD_RECORD 328
#define CMD_STOP 329
#define CMD_PLAYBACK 330
#define CMD_CHAR_DISPLAY 331
#define CMD_SPRITE_DISPLAY 332
#define CMD_TEXT_DISPLAY 333
#define CMD_SCREENCODE_DISPLAY 334
#define CMD_ENTER_DATA 335
#define CMD_ENTER_BIN_DATA 336
#define CMD_KEYBUF 337
#define CMD_BLOAD 338
#define CMD_BSAVE 339
#define CMD_SCREEN 340
#define CMD_UNTIL 341
#define CMD_CPU 342
#define CMD_BACKTRACE 343
#define CMD_CPUHISTORY 344
#define CMD_MEMMAPZAP 345
#define CMD_MEMMAPSHOW 346
#define CMD_MEMMAPSAVE 347
#define CMD_SCREENSHOT 348
#define CMD_PWD 349
#define CMD_DIR 350
#define CMD_RESOURCE_GET 351
#define CMD_RESOURCE_SET 352
#define CMD_ATTACH 353
#define CMD_DETACH 354
#define CMD_RESET 355
#define CMD_TAPECTRL 356
#define CMD_CARTFREEZE 357
#define L_PAREN 358
#define R_PAREN 359
#define ARG_IMMEDIATE 360
#define REG_A 361
#define REG_X 362
#define REG_Y 363
#define COMMA 364
#define INST_SEP 365
#define REG_B 366
#define REG_C 367
#define REG_D 368
#define REG_E 369
#define REG_H 370
#define REG_L 371
#define REG_AF 372
#define REG_BC 373
#define REG_DE 374
#define REG_HL 375
#define REG_IX 376
#define REG_IY 377
#define REG_SP 378
#define REG_IXH 379
#define REG_IXL 380
#define REG_IYH 381
#define REG_IYL 382
#define STRING 383
#define FILENAME 384
#define R_O_L 385
#define OPCODE 386
#define LABEL 387
#define BANKNAME 388
#define CPUTYPE 389
#define REGISTER 390
#define COMPARE_OP 391
#define RADIX_TYPE 392
#define INPUT_SPEC 393
#define CMD_CHECKPT_ON 394
#define CMD_CHECKPT_OFF 395
#define TOGGLE 396
#define MASK 397




/* Copy the first part of user declarations.  */
#line 1 "mon_parse.y"

/* -*- C -*-
 *
 * mon_parse.y - Parser for the VICE built-in monitor.
 *
 * Written by
 *  Daniel Sladic <sladic@eecg.toronto.edu>
 *  Andreas Boose <viceteam@t-online.de>
 *  Thomas Giesel <skoe@directbox.com>
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 *
 */

#include "vice.h"

#ifndef MINIXVMD
#ifdef __GNUC__
#undef alloca
#define        alloca(n)       __builtin_alloca (n)
#else
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#else  /* Not HAVE_ALLOCA_H.  */
#if !defined(_AIX) && !defined(WINCE)
#ifndef _MSC_VER
extern char *alloca();
#else
#define alloca(n)   _alloca(n)
#endif  /* MSVC */
#endif /* Not AIX and not WINCE.  */
#endif /* HAVE_ALLOCA_H.  */
#endif /* GCC.  */
#endif /* MINIXVMD */

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "asm.h"
#include "console.h"
#include "lib.h"
#include "machine.h"
#include "mon_breakpoint.h"
#include "mon_command.h"
#include "mon_disassemble.h"
#include "mon_drive.h"
#include "mon_file.h"
#include "mon_memory.h"
#include "mon_util.h"
#include "montypes.h"
#include "types.h"
#include "uimon.h"


#define join_ints(x,y) (LO16_TO_HI16(x)|y)
#define separate_int1(x) (HI16_TO_LO16(x))
#define separate_int2(x) (LO16(x))

static int yyerror(char *s);
static int temp;
static int resolve_datatype(unsigned guess_type, const char *num);
static int resolve_range(enum t_memspace memspace, MON_ADDR range[2], 
                         const char *num);
static void mon_quit(void);

#ifdef __IBMC__
static void __yy_memcpy (char *to, char *from, int count);
#endif

/* Defined in the lexer */
extern int new_cmd, opt_asm;
extern void free_buffer(void);
extern void make_buffer(char *str);
extern int yylex(void);
extern int cur_len, last_len;

#define ERR_ILLEGAL_INPUT 1     /* Generic error as returned by yacc.  */
#define ERR_RANGE_BAD_START 2
#define ERR_RANGE_BAD_END 3
#define ERR_BAD_CMD 4
#define ERR_EXPECT_BRKNUM 5
#define ERR_EXPECT_END_CMD 6
#define ERR_MISSING_CLOSE_PAREN 7
#define ERR_INCOMPLETE_COMPARE_OP 8
#define ERR_EXPECT_FILENAME 9
#define ERR_ADDR_TOO_BIG 10
#define ERR_IMM_TOO_BIG 11
#define ERR_EXPECT_STRING 12
#define ERR_UNDEFINED_LABEL 13
#define ERR_EXPECT_DEVICE_NUM 14
#define ERR_EXPECT_ADDRESS 15

#define BAD_ADDR (new_addr(e_invalid_space, 0))
#define CHECK_ADDR(x) ((x) == addr_mask(x))



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 116 "mon_parse.y"
typedef union YYSTYPE {
    MON_ADDR a;
    MON_ADDR range[2];
    int i;
    REG_ID reg;
    CONDITIONAL cond_op;
    cond_node_t *cond_node;
    RADIXTYPE rt;
    ACTION action;
    char *str;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 487 "mon_parse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 499 "mon_parse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  275
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1570

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  149
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  50
/* YYNRULES -- Number of rules. */
#define YYNRULES  256
/* YYNRULES -- Number of states. */
#define YYNSTATES  504

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   397

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     147,   148,   145,   143,     2,   144,     2,   146,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    48,    52,    56,    62,    66,    69,    73,
      76,    80,    84,    87,    92,    95,   100,   103,   108,   111,
     116,   119,   122,   125,   130,   133,   136,   141,   147,   153,
     157,   163,   167,   172,   175,   180,   185,   188,   190,   193,
     197,   201,   207,   211,   217,   221,   227,   231,   237,   241,
     244,   245,   251,   255,   259,   262,   268,   274,   280,   286,
     292,   296,   299,   303,   306,   310,   313,   317,   320,   324,
     327,   331,   335,   341,   347,   351,   354,   357,   360,   363,
     367,   371,   375,   381,   385,   388,   394,   400,   405,   409,
     412,   416,   419,   423,   426,   429,   433,   437,   440,   444,
     448,   452,   456,   459,   463,   467,   473,   479,   485,   489,
     494,   500,   505,   511,   516,   522,   528,   533,   537,   541,
     544,   548,   553,   556,   558,   560,   561,   563,   565,   567,
     569,   571,   572,   574,   577,   581,   583,   587,   589,   591,
     593,   595,   599,   601,   605,   608,   609,   611,   615,   617,
     619,   620,   622,   624,   626,   628,   630,   632,   634,   638,
     642,   646,   650,   654,   658,   660,   664,   668,   672,   676,
     678,   680,   682,   686,   688,   690,   692,   695,   697,   699,
     701,   703,   705,   707,   709,   711,   713,   715,   717,   719,
     721,   723,   725,   727,   729,   731,   735,   739,   742,   745,
     747,   749,   752,   754,   758,   762,   766,   772,   778,   782,
     786,   790,   794,   798,   802,   808,   814,   820,   826,   827,
     829,   831,   833,   835,   837,   839,   841,   843,   845,   847,
     849,   851,   853,   855,   857,   859,   861
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     150,     0,    -1,   151,    -1,   196,    23,    -1,    23,    -1,
     153,    -1,   151,   153,    -1,    24,    -1,    23,    -1,     1,
      -1,   154,    -1,   156,    -1,   159,    -1,   157,    -1,   160,
      -1,   161,    -1,   162,    -1,   163,    -1,   164,    -1,   165,
      -1,   166,    -1,    13,    -1,    67,   152,    -1,    67,   181,
     152,    -1,    67,   133,   152,    -1,    67,   181,   180,   133,
     152,    -1,    38,   179,   152,    -1,    46,   152,    -1,    87,
     134,   152,    -1,    26,   152,    -1,    49,   169,   152,    -1,
      50,   169,   152,    -1,    58,   152,    -1,    58,   180,   184,
     152,    -1,    57,   152,    -1,    57,   180,   184,   152,    -1,
      29,   152,    -1,    29,   180,   184,   152,    -1,    30,   152,
      -1,    30,   180,   184,   152,    -1,    85,   152,    -1,    88,
     152,    -1,    89,   152,    -1,    89,   180,   184,   152,    -1,
      90,   152,    -1,    91,   152,    -1,    91,   180,   184,   152,
      -1,    91,   180,   184,   176,   152,    -1,    92,   169,   180,
     184,   152,    -1,    93,   169,   152,    -1,    93,   169,   180,
     184,   152,    -1,    96,   128,   152,    -1,    97,   128,   128,
     152,    -1,   100,   152,    -1,   100,   180,   184,   152,    -1,
     101,   180,   184,   152,    -1,   102,   152,    -1,   155,    -1,
      39,   152,    -1,    39,   181,   152,    -1,    39,   173,   152,
      -1,    68,   181,   180,   169,   152,    -1,    68,   169,   152,
      -1,    69,   181,   180,   169,   152,    -1,    69,   169,   152,
      -1,    70,   179,   180,   132,   152,    -1,    71,   132,   152,
      -1,    71,   181,   180,   132,   152,    -1,    72,   181,   152,
      -1,    72,   152,    -1,    -1,    55,   179,   158,   197,   152,
      -1,    55,   179,   152,    -1,    56,   176,   152,    -1,    56,
     152,    -1,    37,   177,   180,   179,   152,    -1,    48,   177,
     180,   179,   152,    -1,    36,   177,   180,   187,   152,    -1,
      35,   177,   180,   189,   152,    -1,    43,   137,   180,   176,
     152,    -1,    43,   176,   152,    -1,    43,   152,    -1,    76,
     176,   152,    -1,    76,   152,    -1,    77,   176,   152,    -1,
      77,   152,    -1,    78,   176,   152,    -1,    78,   152,    -1,
      79,   176,   152,    -1,    79,   152,    -1,    44,   176,   152,
      -1,    86,   176,   152,    -1,    44,   176,    15,   185,   152,
      -1,    62,   171,   180,   176,   152,    -1,    45,   176,   152,
      -1,    44,   152,    -1,    86,   152,    -1,    45,   152,    -1,
      62,   152,    -1,   139,   175,   152,    -1,   140,   175,   152,
      -1,    34,   175,   152,    -1,    34,   175,   180,   184,   152,
      -1,    52,   175,   152,    -1,    52,   152,    -1,    53,   175,
      15,   185,   152,    -1,    54,   175,   180,   128,   152,    -1,
      54,   175,     1,   152,    -1,    25,   141,   152,    -1,    25,
     152,    -1,    42,   137,   152,    -1,    42,   152,    -1,    60,
     181,   152,    -1,    65,   152,    -1,    51,   152,    -1,    63,
     167,   152,    -1,    59,   184,   152,    -1,    61,   152,    -1,
      61,   167,   152,    -1,    64,   167,   152,    -1,     7,   184,
     152,    -1,    66,   167,   152,    -1,    94,   152,    -1,    95,
     168,   152,    -1,    82,   167,   152,    -1,    31,   169,   170,
     178,   152,    -1,    83,   169,   170,   178,   152,    -1,    32,
     169,   170,   177,   152,    -1,    32,   169,     1,    -1,    32,
     169,   170,     1,    -1,    84,   169,   170,   177,   152,    -1,
      84,   169,   170,     1,    -1,    33,   169,   170,   179,   152,
      -1,    33,   169,   170,     1,    -1,    27,   184,   184,   178,
     152,    -1,    28,   184,   184,   179,   152,    -1,    98,   169,
     184,   152,    -1,    99,   184,   152,    -1,    73,   169,   152,
      -1,    74,   152,    -1,    75,   169,   152,    -1,    80,   179,
     187,   152,    -1,    81,   152,    -1,   130,    -1,   130,    -1,
      -1,   129,    -1,     1,    -1,   184,    -1,     1,    -1,    14,
      -1,    -1,   135,    -1,   181,   135,    -1,   173,    21,   174,
      -1,   174,    -1,   172,    22,   194,    -1,   192,    -1,     1,
      -1,   177,    -1,   179,    -1,   179,   180,   179,    -1,     9,
      -1,   181,   180,     9,    -1,   180,   179,    -1,    -1,   182,
      -1,   181,   180,   182,    -1,   132,    -1,   109,    -1,    -1,
      16,    -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,
     183,    -1,   194,    -1,   184,   143,   184,    -1,   184,   144,
     184,    -1,   184,   145,   184,    -1,   184,   146,   184,    -1,
     147,   184,   148,    -1,   147,   184,     1,    -1,   191,    -1,
     185,   136,   185,    -1,   185,   136,     1,    -1,   103,   185,
     104,    -1,   103,   185,     1,    -1,   186,    -1,   172,    -1,
     194,    -1,   187,   180,   188,    -1,   188,    -1,   194,    -1,
     128,    -1,   189,   190,    -1,   190,    -1,   194,    -1,   142,
      -1,   128,    -1,   194,    -1,   172,    -1,     4,    -1,    12,
      -1,    11,    -1,    10,    -1,    12,    -1,    11,    -1,    10,
      -1,     3,    -1,     4,    -1,     5,    -1,     6,    -1,   193,
      -1,   195,   110,   196,    -1,   196,   110,   196,    -1,   196,
     110,    -1,   131,   198,    -1,   196,    -1,   195,    -1,   105,
     194,    -1,   194,    -1,   194,   109,   107,    -1,   194,   109,
     108,    -1,   103,   194,   104,    -1,   103,   194,   109,   107,
     104,    -1,   103,   194,   104,   109,   108,    -1,   103,   118,
     104,    -1,   103,   119,   104,    -1,   103,   120,   104,    -1,
     103,   121,   104,    -1,   103,   122,   104,    -1,   103,   123,
     104,    -1,   103,   194,   104,   109,   106,    -1,   103,   194,
     104,   109,   120,    -1,   103,   194,   104,   109,   121,    -1,
     103,   194,   104,   109,   122,    -1,    -1,   106,    -1,   111,
      -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,   124,
      -1,   126,    -1,   116,    -1,   125,    -1,   127,    -1,   117,
      -1,   118,    -1,   119,    -1,   120,    -1,   121,    -1,   122,
      -1,   123,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   171,   171,   172,   173,   176,   177,   180,   181,   182,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   199,   201,   203,   205,   207,   209,   211,   213,
     215,   217,   219,   221,   223,   225,   227,   229,   231,   233,
     235,   237,   239,   241,   243,   245,   247,   249,   251,   253,
     255,   257,   259,   261,   263,   265,   267,   269,   272,   274,
     276,   279,   285,   291,   293,   295,   297,   299,   301,   303,
     308,   307,   310,   312,   314,   318,   320,   322,   324,   326,
     328,   330,   332,   334,   336,   338,   340,   342,   344,   346,
     350,   355,   360,   366,   372,   377,   379,   381,   383,   388,
     390,   392,   394,   396,   398,   400,   402,   404,   408,   410,
     415,   417,   435,   440,   442,   446,   448,   450,   452,   454,
     456,   458,   460,   462,   464,   468,   470,   472,   474,   476,
     478,   480,   482,   484,   486,   488,   490,   492,   496,   498,
     500,   504,   506,   510,   513,   514,   517,   518,   521,   522,
     525,   526,   529,   530,   533,   534,   537,   541,   542,   545,
     546,   549,   550,   552,   556,   557,   560,   565,   570,   580,
     581,   584,   585,   586,   587,   588,   591,   593,   595,   596,
     597,   598,   599,   600,   601,   604,   609,   611,   613,   615,
     619,   625,   633,   634,   637,   638,   641,   642,   645,   646,
     647,   650,   651,   654,   655,   656,   657,   660,   661,   662,
     665,   666,   667,   668,   669,   672,   673,   674,   677,   687,
     688,   691,   695,   700,   705,   710,   712,   714,   716,   717,
     718,   719,   720,   721,   722,   724,   726,   728,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "H_NUMBER", "D_NUMBER", "O_NUMBER",
  "B_NUMBER", "CONVERT_OP", "B_DATA", "H_RANGE_GUESS", "D_NUMBER_GUESS",
  "O_NUMBER_GUESS", "B_NUMBER_GUESS", "BAD_CMD", "MEM_OP", "IF",
  "MEM_COMP", "MEM_DISK8", "MEM_DISK9", "MEM_DISK10", "MEM_DISK11",
  "REG_ASGN_SEP", "EQUALS", "TRAIL", "CMD_SEP", "CMD_SIDEFX", "CMD_RETURN",
  "CMD_BLOCK_READ", "CMD_BLOCK_WRITE", "CMD_UP", "CMD_DOWN", "CMD_LOAD",
  "CMD_SAVE", "CMD_VERIFY", "CMD_IGNORE", "CMD_HUNT", "CMD_FILL",
  "CMD_MOVE", "CMD_GOTO", "CMD_REGISTERS", "CMD_READSPACE",
  "CMD_WRITESPACE", "CMD_RADIX", "CMD_MEM_DISPLAY", "CMD_BREAK",
  "CMD_TRACE", "CMD_IO", "CMD_BRMON", "CMD_COMPARE", "CMD_DUMP",
  "CMD_UNDUMP", "CMD_EXIT", "CMD_DELETE", "CMD_CONDITION", "CMD_COMMAND",
  "CMD_ASSEMBLE", "CMD_DISASSEMBLE", "CMD_NEXT", "CMD_STEP", "CMD_PRINT",
  "CMD_DEVICE", "CMD_HELP", "CMD_WATCH", "CMD_DISK", "CMD_SYSTEM",
  "CMD_QUIT", "CMD_CHDIR", "CMD_BANK", "CMD_LOAD_LABELS",
  "CMD_SAVE_LABELS", "CMD_ADD_LABEL", "CMD_DEL_LABEL", "CMD_SHOW_LABELS",
  "CMD_RECORD", "CMD_STOP", "CMD_PLAYBACK", "CMD_CHAR_DISPLAY",
  "CMD_SPRITE_DISPLAY", "CMD_TEXT_DISPLAY", "CMD_SCREENCODE_DISPLAY",
  "CMD_ENTER_DATA", "CMD_ENTER_BIN_DATA", "CMD_KEYBUF", "CMD_BLOAD",
  "CMD_BSAVE", "CMD_SCREEN", "CMD_UNTIL", "CMD_CPU", "CMD_BACKTRACE",
  "CMD_CPUHISTORY", "CMD_MEMMAPZAP", "CMD_MEMMAPSHOW", "CMD_MEMMAPSAVE",
  "CMD_SCREENSHOT", "CMD_PWD", "CMD_DIR", "CMD_RESOURCE_GET",
  "CMD_RESOURCE_SET", "CMD_ATTACH", "CMD_DETACH", "CMD_RESET",
  "CMD_TAPECTRL", "CMD_CARTFREEZE", "L_PAREN", "R_PAREN", "ARG_IMMEDIATE",
  "REG_A", "REG_X", "REG_Y", "COMMA", "INST_SEP", "REG_B", "REG_C",
  "REG_D", "REG_E", "REG_H", "REG_L", "REG_AF", "REG_BC", "REG_DE",
  "REG_HL", "REG_IX", "REG_IY", "REG_SP", "REG_IXH", "REG_IXL", "REG_IYH",
  "REG_IYL", "STRING", "FILENAME", "R_O_L", "OPCODE", "LABEL", "BANKNAME",
  "CPUTYPE", "REGISTER", "COMPARE_OP", "RADIX_TYPE", "INPUT_SPEC",
  "CMD_CHECKPT_ON", "CMD_CHECKPT_OFF", "TOGGLE", "MASK", "'+'", "'-'",
  "'*'", "'/'", "'('", "')'", "$accept", "top_level", "command_list",
  "end_cmd", "command", "machine_state_rules", "register_mod",
  "symbol_table_rules", "asm_rules", "@1", "memory_rules",
  "checkpoint_rules", "checkpoint_control_rules", "monitor_state_rules",
  "monitor_misc_rules", "disk_rules", "cmd_file_rules", "data_entry_rules",
  "rest_of_line", "opt_rest_of_line", "filename", "device_num",
  "opt_mem_op", "register", "reg_list", "reg_asgn", "breakpt_num",
  "address_opt_range", "address_range", "opt_address", "address",
  "opt_sep", "memspace", "memloc", "memaddr", "expression", "cond_expr",
  "compare_operand", "data_list", "data_element", "hunt_list",
  "hunt_element", "value", "d_number", "guess_default", "number",
  "assembly_instr_list", "assembly_instruction", "post_assemble",
  "asm_operand_mode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    43,    45,    42,    47,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,   149,   150,   150,   150,   151,   151,   152,   152,   152,
     153,   153,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   153,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   155,   155,
     155,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     158,   157,   157,   157,   157,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     160,   160,   160,   160,   160,   160,   160,   160,   160,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   162,   162,
     162,   162,   162,   162,   162,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   163,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   164,   165,   165,
     165,   166,   166,   167,   168,   168,   169,   169,   170,   170,
     171,   171,   172,   172,   173,   173,   174,   175,   175,   176,
     176,   177,   177,   177,   178,   178,   179,   179,   179,   180,
     180,   181,   181,   181,   181,   181,   182,   183,   184,   184,
     184,   184,   184,   184,   184,   185,   185,   185,   185,   185,
     186,   186,   187,   187,   188,   188,   189,   189,   190,   190,
     190,   191,   191,   192,   192,   192,   192,   193,   193,   193,
     194,   194,   194,   194,   194,   195,   195,   195,   196,   197,
     197,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   198
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     5,     3,     2,     3,     2,
       3,     3,     2,     4,     2,     4,     2,     4,     2,     4,
       2,     2,     2,     4,     2,     2,     4,     5,     5,     3,
       5,     3,     4,     2,     4,     4,     2,     1,     2,     3,
       3,     5,     3,     5,     3,     5,     3,     5,     3,     2,
       0,     5,     3,     3,     2,     5,     5,     5,     5,     5,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     3,     5,     5,     3,     2,     2,     2,     2,     3,
       3,     3,     5,     3,     2,     5,     5,     4,     3,     2,
       3,     2,     3,     2,     2,     3,     3,     2,     3,     3,
       3,     3,     2,     3,     3,     5,     5,     5,     3,     4,
       5,     4,     5,     4,     5,     5,     4,     3,     3,     2,
       3,     4,     2,     1,     1,     0,     1,     1,     1,     1,
       1,     0,     1,     2,     3,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     2,     0,     1,     3,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     1,     3,     3,     3,     3,     1,
       1,     1,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     2,     2,     1,
       1,     2,     1,     3,     3,     3,     5,     5,     3,     3,
       3,     3,     3,     3,     5,     5,     5,     5,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       0,     0,    21,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   145,     0,     0,     0,     0,     0,   170,     0,   238,
       0,     0,     0,     2,     5,    10,    57,    11,    13,    12,
      14,    15,    16,    17,    18,    19,    20,     0,   210,   211,
     212,   213,   209,   208,   207,   171,   172,   173,   174,   175,
     152,     0,   202,     0,     0,   184,   214,   201,     9,     8,
       7,     0,   109,    29,     0,     0,   169,    36,     0,    38,
       0,   147,   146,     0,     0,     0,   158,   203,   206,   205,
     204,     0,   157,   162,   168,   170,   170,   170,   166,   176,
     177,   170,   170,     0,   170,    58,     0,     0,   155,     0,
       0,   111,   170,    81,     0,   159,   170,    95,     0,    97,
       0,    27,   170,     0,     0,   114,     9,   104,     0,     0,
       0,     0,    74,     0,    34,     0,    32,     0,     0,     0,
     143,   117,     0,   150,    98,   170,     0,     0,   113,     0,
       0,    22,     0,     0,   170,     0,   170,   170,     0,   170,
      69,     0,     0,   139,     0,    83,     0,    85,     0,    87,
       0,    89,     0,     0,   142,     0,     0,     0,    40,    96,
       0,     0,    41,    42,     0,    44,    45,     0,   170,     0,
     122,   144,     0,     0,     0,     0,     0,    53,     0,     0,
      56,     0,     0,   239,   240,   241,   242,   243,   244,   247,
     250,   251,   252,   253,   254,   255,   256,   245,   248,   246,
     249,   222,   218,     0,     0,     1,     6,     3,     0,   153,
       0,     0,     0,     0,   120,   108,   170,     0,     0,     0,
     149,   170,   148,   128,     0,     0,   101,     0,     0,     0,
       0,     0,     0,    26,     0,     0,     0,    60,    59,   110,
       0,    80,     0,    90,    94,     0,    30,    31,   103,     0,
       0,     0,    72,     0,    73,     0,     0,   116,   112,   118,
       0,   115,   119,   121,    24,    23,     0,    62,     0,    64,
       0,     0,    66,     0,    68,   138,   140,    82,    84,    86,
      88,   195,     0,   193,   194,   124,   170,     0,    91,    28,
       0,     0,     0,    49,     0,   123,    51,     0,     0,   137,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   221,
       0,    99,   100,   183,   182,   178,   179,   180,   181,     0,
       0,     0,    37,    39,     0,   129,     0,   133,     0,     0,
     200,   199,     0,   197,   198,   161,   163,   167,     0,     0,
     156,   154,     0,     0,   190,     0,   189,   191,     0,     0,
     107,     0,   220,   219,     0,    35,    33,     0,     0,     0,
       0,     0,     0,   141,     0,     0,   131,     0,    43,    46,
       0,     0,     0,    52,   136,    54,    55,   228,   229,   230,
     231,   232,   233,   225,     0,   223,   224,   134,   164,   135,
     125,   127,   132,   102,    78,   196,    77,    75,    79,     0,
       0,    92,    76,   105,   106,     0,   217,    71,    93,    25,
      61,    63,    65,    67,   192,   126,   130,    47,    48,    50,
       0,     0,   188,   187,   186,   185,   215,   216,   234,   227,
     235,   236,   237,   226
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    82,    83,   122,    84,    85,    86,    87,    88,   323,
      89,    90,    91,    92,    93,    94,    95,    96,   192,   242,
     133,   291,   195,   112,   157,   158,   141,   164,   165,   389,
     166,   390,   113,   148,   149,   292,   415,   416,   352,   353,
     402,   403,   115,   142,   116,   150,   422,    97,   424,   272
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -322
static const short int yypact[] =
{
    1042,   250,  -322,  -322,     2,   172,   250,   250,    76,    76,
      10,    10,    10,   479,  1372,  1372,  1372,  1391,   297,    15,
     885,  1015,  1015,   172,  1372,    10,    10,   172,   497,   479,
     479,  1391,  1015,    76,    76,   250,   670,   107,  1290,  -109,
    -109,   172,  -109,   594,   675,   675,  1391,   545,   701,    10,
     172,    10,  1015,  1015,  1015,  1015,  1391,   172,  -109,    10,
      10,   172,  1015,  -104,   172,    76,   172,    76,    10,    10,
     172,   -97,   -88,   -85,    10,   250,    76,   -61,   172,  1437,
     479,   479,    71,  1158,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,    50,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,   250,  -322,   -46,    23,  -322,  -322,  -322,  -322,  -322,
    -322,   172,  -322,  -322,   405,   405,  -322,  -322,   250,  -322,
     250,  -322,  -322,   446,   643,   446,  -322,  -322,  -322,  -322,
    -322,    76,  -322,  -322,  -322,   -61,   -61,   -61,  -322,  -322,
    -322,   -61,   -61,   172,   -61,  -322,    69,   206,  -322,    30,
     172,  -322,   -61,  -322,   172,  -322,   177,  -322,   359,  -322,
     172,  -322,   -61,   172,   172,  -322,   211,  -322,   172,    83,
      65,   152,  -322,   172,  -322,   250,  -322,   250,    23,   172,
    -322,  -322,   172,  -322,  -322,   -61,   172,   172,  -322,   172,
     172,  -322,   140,   172,   -61,   172,   -61,   -61,   172,   -61,
    -322,   172,   172,  -322,   172,  -322,   172,  -322,   172,  -322,
     172,  -322,   172,   620,  -322,   172,   446,   446,  -322,  -322,
     172,   172,  -322,  -322,   250,  -322,  -322,   250,   -61,    76,
    -322,  -322,   172,   172,   -26,   250,    23,  -322,   250,   250,
    -322,  1447,   855,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,    -2,  -322,   172,   172,  -322,  -322,  -322,     3,  -322,
     250,   250,   250,   250,  -322,  -322,    13,   808,    23,    23,
    -322,   190,    60,  1150,  1314,  1354,  -322,   250,    52,  1391,
     764,   620,  1391,  -322,   855,   855,   420,  -322,  -322,  -322,
    1372,  -322,  1258,  -322,  -322,  1391,  -322,  -322,  -322,  1258,
     172,   -19,  -322,   -20,  -322,    23,    23,  -322,  -322,  -322,
    1372,  -322,  -322,  -322,  -322,  -322,    -8,  -322,    10,  -322,
      10,    -6,  -322,     4,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  1413,  -322,  -322,  -322,   190,  1334,  -322,  -322,
      23,   783,   250,  -322,   250,  -322,  -322,   172,    23,  -322,
      23,    23,    33,    38,    40,    41,    58,    67,   -89,  -322,
     -95,  -322,  -322,  -322,  -322,   -29,   -29,  -322,  -322,   172,
    1391,   172,  -322,  -322,   172,  -322,   172,  -322,   172,    23,
    -322,  -322,   833,  -322,  -322,  -322,  -322,  -322,  1413,   172,
    -322,  -322,   172,  1258,  -322,    82,  -322,  -322,   172,    82,
    -322,   172,    62,    79,   172,  -322,  -322,   172,   172,   172,
     172,   172,   172,  -322,   620,   172,  -322,   172,  -322,  -322,
     172,    23,    23,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,    31,    72,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,    34,
     954,  -322,  -322,  -322,  -322,   -20,   -20,  -322,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
     204,    93,  -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,  -322
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -322,  -322,  -322,   314,   116,  -322,  -322,  -322,  -322,  -322,
    -322,  -322,  -322,  -322,  -322,  -322,  -322,  -322,   251,  -322,
      16,  -112,  -322,   -17,  -322,   -96,   191,    -3,    -7,  -259,
     104,    36,   553,  -232,  -322,   636,  -309,  -322,   -92,  -219,
    -322,  -185,  -322,  -322,  -322,    -1,  -322,  -321,  -322,  -322
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -171
static const short int yytable[] =
{
     117,   156,   423,   118,   383,   117,   117,   145,   151,   152,
     419,   131,   455,   456,  -165,   453,   118,   172,   168,   170,
     454,   190,   294,   295,   118,   119,   120,   134,   135,   183,
     231,   118,   394,   241,   117,   492,  -165,  -165,   119,   120,
     243,   173,   174,   244,   128,   130,   119,   120,   126,   216,
     218,   220,   222,   119,   120,    98,    99,   100,   101,   230,
     203,   205,   102,   103,   104,   212,   320,   214,   407,   185,
     187,   275,   407,   277,   117,   226,   227,   118,   271,  -170,
    -170,  -170,  -170,   118,   238,   239,  -170,  -170,  -170,   279,
     245,   305,  -170,  -170,  -170,  -170,  -170,   435,   319,   119,
     120,   234,   367,   237,   469,   119,   120,   380,   118,   421,
     117,    79,   248,   249,   356,   357,   282,   283,   146,   146,
     146,   153,   126,   117,   117,   428,   431,   117,   146,   117,
     119,   120,   117,   117,   117,   181,   432,   447,   493,   132,
     490,   118,   448,   121,   449,   450,   280,   281,   282,   283,
     207,   384,   160,   118,   496,   497,   280,   281,   282,   283,
     223,   495,   451,   119,   120,   279,   280,   281,   282,   283,
     470,   452,   475,   118,   126,   119,   120,   297,  -160,   491,
     400,   298,   299,   300,   117,   126,   117,   301,   302,   476,
     304,  -165,  -160,  -170,   401,   119,   120,   503,   310,   276,
    -160,  -160,   299,   280,   281,   282,   283,   118,   315,   408,
     411,  -170,  -158,  -165,  -165,   484,   321,   465,   470,   178,
     179,   180,   354,  -170,     0,   117,   117,   306,     0,   119,
     120,   330,     0,   117,  -158,  -158,   117,   190,   336,     0,
     338,     0,   340,   341,   117,   343,     0,   117,   117,   126,
     378,   379,     0,    98,    99,   100,   101,     0,     0,     0,
     102,   103,   104,     0,     0,     0,   105,   106,   107,   108,
     109,   273,   274,  -170,   362,   364,     0,     0,     0,   117,
     117,   117,   117,   -70,     0,     0,   126,   396,     0,   156,
     196,   197,     0,   199,     0,   414,   117,   404,   118,   126,
     354,     0,   414,     0,   410,     0,     0,   412,     0,   225,
     498,   417,   499,   105,   106,   107,   108,   109,   417,   123,
     119,   120,   127,   129,   500,   501,   502,   427,     0,     0,
       0,     0,   155,   161,   163,   167,   169,   171,     0,     0,
       0,   175,   177,     0,     0,     0,   182,   184,   186,     0,
     437,   191,   194,     0,   429,   198,   430,   201,   440,     0,
     118,   117,   210,   117,   213,     0,   215,   217,   219,   221,
       0,   224,     0,     0,   312,   228,   229,     0,   232,   233,
     235,   236,   119,   120,   240,   110,     0,     0,   434,     0,
     247,   391,   250,     0,     0,     0,   414,   111,   146,   398,
       0,   404,     0,   405,     0,     0,   409,     0,    98,    99,
     100,   101,   417,     0,     0,   102,   103,   104,     0,   418,
       0,   105,   106,   107,   108,   109,     0,     0,   284,     0,
       0,     0,   110,   354,     0,   285,   105,   106,   107,   108,
     109,     0,     0,     0,   434,     0,     0,   290,     0,    98,
      99,   100,   101,   414,     0,   296,   102,   103,   104,     0,
       0,   146,   105,   106,   107,   108,   109,   303,     0,   417,
       0,   307,     0,   308,   309,     0,     0,     0,   311,     0,
     136,     0,   313,   137,   314,     0,     0,   316,   317,   138,
     139,   140,   318,     0,   458,   322,     0,   324,   176,     0,
       0,   137,   327,   328,     0,     0,   329,   138,   139,   140,
     331,   332,     0,   333,   334,     0,   335,   337,     0,   339,
     119,   120,   342,     0,     0,   344,   345,     0,   346,     0,
     347,     0,   348,     0,   349,     0,   350,     0,     0,   355,
     110,     0,     0,     0,   358,   359,     0,     0,   280,   281,
     282,   283,   111,   363,     0,   110,   365,   366,     0,     0,
     369,   105,   106,   107,   108,   109,     0,   147,   147,   147,
     154,   159,     0,   147,   147,   147,     0,   147,     0,     0,
       0,   110,     0,     0,   154,   147,     0,   381,   382,   189,
       0,     0,     0,   111,     0,   118,   202,   204,   206,   154,
     209,   211,   392,   393,     0,   147,   147,   147,   147,   154,
     105,   106,   107,   108,   109,   147,     0,   119,   120,     0,
       0,     0,     0,    98,    99,   100,   101,     0,     0,     0,
     102,   103,   104,     0,   420,     0,     0,   114,     0,   425,
     426,     0,   124,   125,   293,     0,    98,    99,   100,   101,
       0,     0,     0,   102,   103,   104,     0,     0,     0,   105,
     106,   107,   108,   109,     0,     0,   433,     0,     0,     0,
       0,   188,     0,     0,   438,   439,   131,   208,     0,     0,
       0,   443,   444,     0,   445,   446,   105,   106,   107,   108,
     109,   105,   106,   107,   108,   109,     0,     0,     0,     0,
       0,     0,   118,   457,     0,   459,     0,     0,   460,     0,
     461,   246,   462,   463,     0,     0,   464,   105,   106,   107,
     108,   109,   466,   467,   119,   120,   468,   200,     0,   471,
       0,     0,   472,   473,     0,   474,     0,     0,   477,     0,
       0,   478,   479,   480,   481,   482,   483,   278,   351,   485,
       0,   486,     0,     0,   487,   488,   489,     0,     0,     0,
     286,   287,     0,     0,   288,     0,   289,    98,    99,   100,
     101,     0,     0,   406,   102,   103,   104,     0,   110,     0,
       0,     0,     0,     0,   118,     0,    98,    99,   100,   101,
     111,     0,   143,   102,   103,   104,     0,     0,     0,   105,
     106,   107,   108,   109,   132,     0,   119,   120,     0,     0,
       0,    98,    99,   100,   101,     0,     0,     0,   102,   103,
     104,   325,     0,   326,   105,   106,   107,   108,   109,     0,
       0,     0,     0,     0,   118,     0,    98,    99,   100,   101,
     154,     0,     0,   102,   103,   104,     0,   147,   154,     0,
       0,     0,   154,     0,     0,   154,   119,   120,    98,    99,
     100,   101,     0,   147,     0,   102,   103,   104,   154,     0,
     360,     0,     0,   361,     0,     0,     0,     0,     0,     0,
       0,   368,     0,   147,   370,   371,   118,     0,    98,    99,
     100,   101,     0,     0,   143,   102,   103,   104,     0,     0,
       0,   105,   106,   107,   108,   109,     0,     0,   119,   120,
     147,     0,     0,     0,   147,   144,   385,   386,   387,   388,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
       0,     0,     0,   399,     0,     0,     0,     0,     0,     0,
     144,     0,     0,   154,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   494,     0,    98,    99,   100,
     101,   400,     0,     0,   102,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,   401,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   441,     0,
     442,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   118,   144,    98,    99,
     100,   101,   162,     0,   143,   102,   103,   104,     0,     0,
       0,   105,   106,   107,   108,   109,     0,     0,   119,   120,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     2,     0,   413,     0,     0,
       0,     0,     0,     0,     0,     3,     0,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,     0,     0,    19,    20,    21,    22,    23,   110,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,     0,     0,   144,     0,     0,
       0,  -149,     0,  -149,  -149,  -149,  -149,     0,     0,  -149,
    -149,  -149,  -149,     0,     0,     1,  -149,  -149,  -149,  -149,
    -149,     2,     0,    79,     0,     0,     0,     0,     0,     0,
       0,    80,    81,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,     0,     0,
      19,    20,    21,    22,    23,     0,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    98,    99,   100,   101,     0,     0,     0,   102,   103,
     104,     0,     0,     0,   105,   106,   107,   108,   109,     0,
       0,     0,  -149,     0,     0,     0,     0,     0,     0,     0,
       0,   118,     0,  -151,  -151,  -151,  -151,    80,    81,  -151,
    -151,  -151,  -151,     0,   193,     0,  -151,  -151,  -151,  -151,
    -151,     0,     0,   119,   120,   395,     0,    98,    99,   100,
     101,     0,     0,   143,   102,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,   436,     0,    98,    99,   100,
     101,     0,     0,   143,   102,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,   397,     0,    98,    99,   100,
     101,   413,     0,     0,   102,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,    98,    99,   100,   101,     0,
       0,   143,   102,   103,   104,     0,     0,     0,   105,   106,
     107,   108,   109,   110,    98,    99,   100,   101,     0,  -151,
       0,   102,   103,   104,     0,     0,     0,   105,   106,   107,
     108,   109,     0,     0,   118,     0,  -170,  -170,  -170,  -170,
       0,     0,  -151,  -170,  -170,  -170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   119,   120,     0,     0,
      98,    99,   100,   101,     0,     0,   144,   102,   103,   104,
      98,    99,   100,   101,     0,     0,     0,   102,   103,   104,
       0,     0,     0,     0,     0,     0,   144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   144,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   126,   144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     251,  -170,   252,   253,     0,     0,     0,     0,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   372,   373,   374,   375,   376,
     377
};

static const short int yycheck[] =
{
       1,    18,   323,     1,     1,     6,     7,    14,    15,    16,
     319,     1,   107,   108,     1,   104,     1,    24,    21,    22,
     109,   130,   134,   135,     1,    23,    24,    11,    12,    32,
     134,     1,   291,   130,    35,     1,    23,    24,    23,    24,
     128,    25,    26,   128,     8,     9,    23,    24,   109,    52,
      53,    54,    55,    23,    24,     3,     4,     5,     6,    62,
      44,    45,    10,    11,    12,    49,     1,    51,   300,    33,
      34,     0,   304,    23,    75,    59,    60,     1,    79,     3,
       4,     5,     6,     1,    68,    69,    10,    11,    12,   135,
      74,    22,    16,    17,    18,    19,    20,   356,    15,    23,
      24,    65,   128,    67,   413,    23,    24,   109,     1,   128,
     111,   131,    76,    77,   226,   227,   145,   146,    14,    15,
      16,    17,   109,   124,   125,   133,   132,   128,    24,   130,
      23,    24,   133,   134,   135,    31,   132,   104,   104,   129,
     109,     1,   104,   141,   104,   104,   143,   144,   145,   146,
      46,   148,   137,     1,   475,   476,   143,   144,   145,   146,
      56,   470,   104,    23,    24,   135,   143,   144,   145,   146,
     136,   104,   110,     1,   109,    23,    24,   141,     1,   107,
     128,   145,   146,   147,   185,   109,   187,   151,   152,   110,
     154,     1,    15,   128,   142,    23,    24,   104,   162,    83,
      23,    24,   166,   143,   144,   145,   146,     1,   172,   301,
     306,   135,     1,    23,    24,   434,   180,   402,   136,    28,
      29,    30,   223,   147,    -1,   226,   227,    21,    -1,    23,
      24,   195,    -1,   234,    23,    24,   237,   130,   202,    -1,
     204,    -1,   206,   207,   245,   209,    -1,   248,   249,   109,
     251,   252,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    80,    81,   133,   238,   239,    -1,    -1,    -1,   280,
     281,   282,   283,   131,    -1,    -1,   109,   294,    -1,   306,
      39,    40,    -1,    42,    -1,   312,   297,   298,     1,   109,
     301,    -1,   319,    -1,   305,    -1,    -1,   310,    -1,    58,
     106,   312,   108,    16,    17,    18,    19,    20,   319,     5,
      23,    24,     8,     9,   120,   121,   122,   330,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    32,    33,    34,    -1,
     357,    37,    38,    -1,   338,    41,   340,    43,   361,    -1,
       1,   362,    48,   364,    50,    -1,    52,    53,    54,    55,
      -1,    57,    -1,    -1,    15,    61,    62,    -1,    64,    65,
      66,    67,    23,    24,    70,   135,    -1,    -1,   352,    -1,
      76,   287,    78,    -1,    -1,    -1,   413,   147,   294,   295,
      -1,   402,    -1,   299,    -1,    -1,   302,    -1,     3,     4,
       5,     6,   413,    -1,    -1,    10,    11,    12,    -1,   315,
      -1,    16,    17,    18,    19,    20,    -1,    -1,   114,    -1,
      -1,    -1,   135,   434,    -1,   121,    16,    17,    18,    19,
      20,    -1,    -1,    -1,   408,    -1,    -1,     1,    -1,     3,
       4,     5,     6,   470,    -1,   141,    10,    11,    12,    -1,
      -1,   357,    16,    17,    18,    19,    20,   153,    -1,   470,
      -1,   157,    -1,   159,   160,    -1,    -1,    -1,   164,    -1,
       1,    -1,   168,     4,   170,    -1,    -1,   173,   174,    10,
      11,    12,   178,    -1,   390,   181,    -1,   183,     1,    -1,
      -1,     4,   188,   189,    -1,    -1,   192,    10,    11,    12,
     196,   197,    -1,   199,   200,    -1,   202,   203,    -1,   205,
      23,    24,   208,    -1,    -1,   211,   212,    -1,   214,    -1,
     216,    -1,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
     135,    -1,    -1,    -1,   230,   231,    -1,    -1,   143,   144,
     145,   146,   147,   239,    -1,   135,   242,   243,    -1,    -1,
     246,    16,    17,    18,    19,    20,    -1,    14,    15,    16,
      17,    18,    -1,    20,    21,    22,    -1,    24,    -1,    -1,
      -1,   135,    -1,    -1,    31,    32,    -1,   273,   274,    36,
      -1,    -1,    -1,   147,    -1,     1,    43,    44,    45,    46,
      47,    48,   288,   289,    -1,    52,    53,    54,    55,    56,
      16,    17,    18,    19,    20,    62,    -1,    23,    24,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
      10,    11,    12,    -1,   320,    -1,    -1,     1,    -1,   325,
     326,    -1,     6,     7,     1,    -1,     3,     4,     5,     6,
      -1,    -1,    -1,    10,    11,    12,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    -1,    -1,   352,    -1,    -1,    -1,
      -1,    35,    -1,    -1,   360,   361,     1,   132,    -1,    -1,
      -1,   367,   368,    -1,   370,   371,    16,    17,    18,    19,
      20,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      -1,    -1,     1,   389,    -1,   391,    -1,    -1,   394,    -1,
     396,    75,   398,   399,    -1,    -1,   402,    16,    17,    18,
      19,    20,   408,   409,    23,    24,   412,   133,    -1,   415,
      -1,    -1,   418,   419,    -1,   421,    -1,    -1,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   111,   128,   435,
      -1,   437,    -1,    -1,   440,   441,   442,    -1,    -1,    -1,
     124,   125,    -1,    -1,   128,    -1,   130,     3,     4,     5,
       6,    -1,    -1,     9,    10,    11,    12,    -1,   135,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
     147,    -1,     9,    10,    11,    12,    -1,    -1,    -1,    16,
      17,    18,    19,    20,   129,    -1,    23,    24,    -1,    -1,
      -1,     3,     4,     5,     6,    -1,    -1,    -1,    10,    11,
      12,   185,    -1,   187,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
     287,    -1,    -1,    10,    11,    12,    -1,   294,   295,    -1,
      -1,    -1,   299,    -1,    -1,   302,    23,    24,     3,     4,
       5,     6,    -1,   310,    -1,    10,    11,    12,   315,    -1,
     234,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   245,    -1,   330,   248,   249,     1,    -1,     3,     4,
       5,     6,    -1,    -1,     9,    10,    11,    12,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    -1,    23,    24,
     357,    -1,    -1,    -1,   361,   132,   280,   281,   282,   283,
      -1,    -1,    -1,    -1,    -1,    -1,   143,   144,   145,   146,
      -1,    -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   143,   144,   145,   146,     1,    -1,     3,     4,     5,
       6,   128,    -1,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    17,    18,    19,    20,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,
     364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,   132,     3,     4,
       5,     6,   137,    -1,     9,    10,    11,    12,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    -1,    23,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,
      -1,    -1,    -1,    -1,    -1,    13,    -1,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    -1,    42,    43,    44,    45,    46,   135,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,   132,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,    -1,    -1,     9,
      10,    11,    12,    -1,    -1,     7,    16,    17,    18,    19,
      20,    13,    -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,   140,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    -1,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     3,     4,     5,     6,    -1,    -1,    -1,    10,    11,
      12,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
      -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,   139,   140,     9,
      10,    11,    12,    -1,    14,    -1,    16,    17,    18,    19,
      20,    -1,    -1,    23,    24,     1,    -1,     3,     4,     5,
       6,    -1,    -1,     9,    10,    11,    12,    -1,    -1,    -1,
      16,    17,    18,    19,    20,     1,    -1,     3,     4,     5,
       6,    -1,    -1,     9,    10,    11,    12,    -1,    -1,    -1,
      16,    17,    18,    19,    20,     1,    -1,     3,     4,     5,
       6,   103,    -1,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    17,    18,    19,    20,     3,     4,     5,     6,    -1,
      -1,     9,    10,    11,    12,    -1,    -1,    -1,    16,    17,
      18,    19,    20,   135,     3,     4,     5,     6,    -1,   109,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    -1,    -1,     1,    -1,     3,     4,     5,     6,
      -1,    -1,   132,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    -1,    -1,
       3,     4,     5,     6,    -1,    -1,   132,    10,    11,    12,
       3,     4,     5,     6,    -1,    -1,    -1,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     103,   128,   105,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   118,   119,   120,   121,   122,
     123
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     7,    13,    23,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    42,
      43,    44,    45,    46,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   131,
     139,   140,   150,   151,   153,   154,   155,   156,   157,   159,
     160,   161,   162,   163,   164,   165,   166,   196,     3,     4,
       5,     6,    10,    11,    12,    16,    17,    18,    19,    20,
     135,   147,   172,   181,   184,   191,   193,   194,     1,    23,
      24,   141,   152,   152,   184,   184,   109,   152,   180,   152,
     180,     1,   129,   169,   169,   169,     1,     4,    10,    11,
      12,   175,   192,     9,   132,   177,   179,   181,   182,   183,
     194,   177,   177,   179,   181,   152,   172,   173,   174,   181,
     137,   152,   137,   152,   176,   177,   179,   152,   176,   152,
     176,   152,   177,   169,   169,   152,     1,   152,   175,   175,
     175,   179,   152,   176,   152,   180,   152,   180,   184,   181,
     130,   152,   167,    14,   152,   171,   167,   167,   152,   167,
     133,   152,   181,   169,   181,   169,   181,   179,   132,   181,
     152,   181,   169,   152,   169,   152,   176,   152,   176,   152,
     176,   152,   176,   179,   152,   167,   169,   169,   152,   152,
     176,   134,   152,   152,   180,   152,   152,   180,   169,   169,
     152,   130,   168,   128,   128,   169,   184,   152,   180,   180,
     152,   103,   105,   106,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   194,   198,   175,   175,     0,   153,    23,   184,   135,
     143,   144,   145,   146,   152,   152,   184,   184,   184,   184,
       1,   170,   184,     1,   170,   170,   152,   180,   180,   180,
     180,   180,   180,   152,   180,    22,    21,   152,   152,   152,
     180,   152,    15,   152,   152,   180,   152,   152,   152,    15,
       1,   180,   152,   158,   152,   184,   184,   152,   152,   152,
     180,   152,   152,   152,   152,   152,   180,   152,   180,   152,
     180,   180,   152,   180,   152,   152,   152,   152,   152,   152,
     152,   128,   187,   188,   194,   152,   170,   170,   152,   152,
     184,   184,   180,   152,   180,   152,   152,   128,   184,   152,
     184,   184,   118,   119,   120,   121,   122,   123,   194,   194,
     109,   152,   152,     1,   148,   184,   184,   184,   184,   178,
     180,   179,   152,   152,   178,     1,   177,     1,   179,   184,
     128,   142,   189,   190,   194,   179,     9,   182,   187,   179,
     194,   174,   176,   103,   172,   185,   186,   194,   179,   185,
     152,   128,   195,   196,   197,   152,   152,   176,   133,   169,
     169,   132,   132,   152,   180,   178,     1,   177,   152,   152,
     176,   184,   184,   152,   152,   152,   152,   104,   104,   104,
     104,   104,   104,   104,   109,   107,   108,   152,   179,   152,
     152,   152,   152,   152,   152,   190,   152,   152,   152,   185,
     136,   152,   152,   152,   152,   110,   110,   152,   152,   152,
     152,   152,   152,   152,   188,   152,   152,   152,   152,   152,
     109,   107,     1,   104,     1,   185,   196,   196,   106,   108,
     120,   121,   122,   104
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 171 "mon_parse.y"
    { (yyval.i) = 0; }
    break;

  case 3:
#line 172 "mon_parse.y"
    { (yyval.i) = 0; }
    break;

  case 4:
#line 173 "mon_parse.y"
    { new_cmd = 1; asm_mode = 0;  (yyval.i) = 0; }
    break;

  case 9:
#line 182 "mon_parse.y"
    { return ERR_EXPECT_END_CMD; }
    break;

  case 21:
#line 196 "mon_parse.y"
    { return ERR_BAD_CMD; }
    break;

  case 22:
#line 200 "mon_parse.y"
    { mon_bank(e_default_space, NULL); }
    break;

  case 23:
#line 202 "mon_parse.y"
    { mon_bank((yyvsp[-1].i), NULL); }
    break;

  case 24:
#line 204 "mon_parse.y"
    { mon_bank(e_default_space, (yyvsp[-1].str)); }
    break;

  case 25:
#line 206 "mon_parse.y"
    { mon_bank((yyvsp[-3].i), (yyvsp[-1].str)); }
    break;

  case 26:
#line 208 "mon_parse.y"
    { mon_jump((yyvsp[-1].a)); }
    break;

  case 27:
#line 210 "mon_parse.y"
    { mon_display_io_regs(); }
    break;

  case 28:
#line 212 "mon_parse.y"
    { monitor_cpu_type_set((yyvsp[-1].str)); }
    break;

  case 29:
#line 214 "mon_parse.y"
    { mon_instruction_return(); }
    break;

  case 30:
#line 216 "mon_parse.y"
    { machine_write_snapshot((yyvsp[-1].str),0,0,0); /* FIXME */ }
    break;

  case 31:
#line 218 "mon_parse.y"
    { machine_read_snapshot((yyvsp[-1].str), 0); }
    break;

  case 32:
#line 220 "mon_parse.y"
    { mon_instructions_step(-1); }
    break;

  case 33:
#line 222 "mon_parse.y"
    { mon_instructions_step((yyvsp[-1].i)); }
    break;

  case 34:
#line 224 "mon_parse.y"
    { mon_instructions_next(-1); }
    break;

  case 35:
#line 226 "mon_parse.y"
    { mon_instructions_next((yyvsp[-1].i)); }
    break;

  case 36:
#line 228 "mon_parse.y"
    { mon_stack_up(-1); }
    break;

  case 37:
#line 230 "mon_parse.y"
    { mon_stack_up((yyvsp[-1].i)); }
    break;

  case 38:
#line 232 "mon_parse.y"
    { mon_stack_down(-1); }
    break;

  case 39:
#line 234 "mon_parse.y"
    { mon_stack_down((yyvsp[-1].i)); }
    break;

  case 40:
#line 236 "mon_parse.y"
    { mon_display_screen(); }
    break;

  case 41:
#line 238 "mon_parse.y"
    { mon_backtrace(); }
    break;

  case 42:
#line 240 "mon_parse.y"
    { mon_cpuhistory(-1); }
    break;

  case 43:
#line 242 "mon_parse.y"
    { mon_cpuhistory((yyvsp[-1].i)); }
    break;

  case 44:
#line 244 "mon_parse.y"
    { mon_memmap_zap(); }
    break;

  case 45:
#line 246 "mon_parse.y"
    { mon_memmap_show(-1,BAD_ADDR,BAD_ADDR); }
    break;

  case 46:
#line 248 "mon_parse.y"
    { mon_memmap_show((yyvsp[-1].i),BAD_ADDR,BAD_ADDR); }
    break;

  case 47:
#line 250 "mon_parse.y"
    { mon_memmap_show((yyvsp[-2].i),(yyvsp[-1].range)[0],(yyvsp[-1].range)[1]); }
    break;

  case 48:
#line 252 "mon_parse.y"
    { mon_memmap_save((yyvsp[-3].str),(yyvsp[-1].i)); }
    break;

  case 49:
#line 254 "mon_parse.y"
    { mon_screenshot_save((yyvsp[-1].str),-1); }
    break;

  case 50:
#line 256 "mon_parse.y"
    { mon_screenshot_save((yyvsp[-3].str),(yyvsp[-1].i)); }
    break;

  case 51:
#line 258 "mon_parse.y"
    { mon_resource_get((yyvsp[-1].str)); }
    break;

  case 52:
#line 260 "mon_parse.y"
    { mon_resource_set((yyvsp[-2].str),(yyvsp[-1].str)); }
    break;

  case 53:
#line 262 "mon_parse.y"
    { mon_reset_machine(-1); }
    break;

  case 54:
#line 264 "mon_parse.y"
    { mon_reset_machine((yyvsp[-1].i)); }
    break;

  case 55:
#line 266 "mon_parse.y"
    { mon_tape_ctrl((yyvsp[-1].i)); }
    break;

  case 56:
#line 268 "mon_parse.y"
    { mon_cart_freeze(); }
    break;

  case 58:
#line 273 "mon_parse.y"
    { (monitor_cpu_type.mon_register_print)(default_memspace); }
    break;

  case 59:
#line 275 "mon_parse.y"
    { (monitor_cpu_type.mon_register_print)((yyvsp[-1].i)); }
    break;

  case 61:
#line 280 "mon_parse.y"
    {
                        /* What about the memspace? */
                        playback = TRUE; playback_name = (yyvsp[-1].str);
                        /*mon_load_symbols($2, $3);*/
                    }
    break;

  case 62:
#line 286 "mon_parse.y"
    {
                        /* What about the memspace? */
                        playback = TRUE; playback_name = (yyvsp[-1].str);
                        /*mon_load_symbols($2, $3);*/
                    }
    break;

  case 63:
#line 292 "mon_parse.y"
    { mon_save_symbols((yyvsp[-3].i), (yyvsp[-1].str)); }
    break;

  case 64:
#line 294 "mon_parse.y"
    { mon_save_symbols(e_default_space, (yyvsp[-1].str)); }
    break;

  case 65:
#line 296 "mon_parse.y"
    { mon_add_name_to_symbol_table((yyvsp[-3].a), (yyvsp[-1].str)); }
    break;

  case 66:
#line 298 "mon_parse.y"
    { mon_remove_name_from_symbol_table(e_default_space, (yyvsp[-1].str)); }
    break;

  case 67:
#line 300 "mon_parse.y"
    { mon_remove_name_from_symbol_table((yyvsp[-3].i), (yyvsp[-1].str)); }
    break;

  case 68:
#line 302 "mon_parse.y"
    { mon_print_symbol_table((yyvsp[-1].i)); }
    break;

  case 69:
#line 304 "mon_parse.y"
    { mon_print_symbol_table(e_default_space); }
    break;

  case 70:
#line 308 "mon_parse.y"
    { mon_start_assemble_mode((yyvsp[0].a), NULL); }
    break;

  case 71:
#line 309 "mon_parse.y"
    { }
    break;

  case 72:
#line 311 "mon_parse.y"
    { mon_start_assemble_mode((yyvsp[-1].a), NULL); }
    break;

  case 73:
#line 313 "mon_parse.y"
    { mon_disassemble_lines((yyvsp[-1].range)[0],(yyvsp[-1].range)[1]); }
    break;

  case 74:
#line 315 "mon_parse.y"
    { mon_disassemble_lines(BAD_ADDR, BAD_ADDR); }
    break;

  case 75:
#line 319 "mon_parse.y"
    { mon_memory_move((yyvsp[-3].range)[0], (yyvsp[-3].range)[1], (yyvsp[-1].a)); }
    break;

  case 76:
#line 321 "mon_parse.y"
    { mon_memory_compare((yyvsp[-3].range)[0], (yyvsp[-3].range)[0], (yyvsp[-1].a)); }
    break;

  case 77:
#line 323 "mon_parse.y"
    { mon_memory_fill((yyvsp[-3].range)[0], (yyvsp[-3].range)[1],(unsigned char *)(yyvsp[-1].str)); }
    break;

  case 78:
#line 325 "mon_parse.y"
    { mon_memory_hunt((yyvsp[-3].range)[0], (yyvsp[-3].range)[1],(unsigned char *)(yyvsp[-1].str)); }
    break;

  case 79:
#line 327 "mon_parse.y"
    { mon_memory_display((yyvsp[-3].rt), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
    break;

  case 80:
#line 329 "mon_parse.y"
    { mon_memory_display(default_radix, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
    break;

  case 81:
#line 331 "mon_parse.y"
    { mon_memory_display(default_radix, BAD_ADDR, BAD_ADDR, DF_PETSCII); }
    break;

  case 82:
#line 333 "mon_parse.y"
    { mon_memory_display_data((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], 8, 8); }
    break;

  case 83:
#line 335 "mon_parse.y"
    { mon_memory_display_data(BAD_ADDR, BAD_ADDR, 8, 8); }
    break;

  case 84:
#line 337 "mon_parse.y"
    { mon_memory_display_data((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], 24, 21); }
    break;

  case 85:
#line 339 "mon_parse.y"
    { mon_memory_display_data(BAD_ADDR, BAD_ADDR, 24, 21); }
    break;

  case 86:
#line 341 "mon_parse.y"
    { mon_memory_display(0, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
    break;

  case 87:
#line 343 "mon_parse.y"
    { mon_memory_display(0, BAD_ADDR, BAD_ADDR, DF_PETSCII); }
    break;

  case 88:
#line 345 "mon_parse.y"
    { mon_memory_display(0, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_SCREEN_CODE); }
    break;

  case 89:
#line 347 "mon_parse.y"
    { mon_memory_display(0, BAD_ADDR, BAD_ADDR, DF_SCREEN_CODE); }
    break;

  case 90:
#line 351 "mon_parse.y"
    {
                      mon_breakpoint_add_checkpoint((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], FALSE, FALSE,
                                                    FALSE, FALSE);
                  }
    break;

  case 91:
#line 356 "mon_parse.y"
    {
                      mon_breakpoint_add_checkpoint((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], FALSE, FALSE,
                                                    FALSE, TRUE);
                  }
    break;

  case 92:
#line 361 "mon_parse.y"
    {
                      temp = mon_breakpoint_add_checkpoint((yyvsp[-3].range)[0], (yyvsp[-3].range)[1], FALSE,
                                                           FALSE, FALSE, FALSE);
                      mon_breakpoint_set_checkpoint_condition(temp, (yyvsp[-1].cond_node));
                  }
    break;

  case 93:
#line 367 "mon_parse.y"
    {
                      mon_breakpoint_add_checkpoint((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], FALSE,
                      ((yyvsp[-3].i) == e_load || (yyvsp[-3].i) == e_load_store),
                      ((yyvsp[-3].i) == e_store || (yyvsp[-3].i) == e_load_store), FALSE);
                  }
    break;

  case 94:
#line 373 "mon_parse.y"
    {
                      mon_breakpoint_add_checkpoint((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], TRUE, FALSE, FALSE,
                                                    FALSE);
                  }
    break;

  case 95:
#line 378 "mon_parse.y"
    { mon_breakpoint_print_checkpoints(); }
    break;

  case 96:
#line 380 "mon_parse.y"
    { mon_breakpoint_print_checkpoints(); }
    break;

  case 97:
#line 382 "mon_parse.y"
    { mon_breakpoint_print_checkpoints(); }
    break;

  case 98:
#line 384 "mon_parse.y"
    { mon_breakpoint_print_checkpoints(); }
    break;

  case 99:
#line 389 "mon_parse.y"
    { mon_breakpoint_switch_checkpoint(e_ON, (yyvsp[-1].i)); }
    break;

  case 100:
#line 391 "mon_parse.y"
    { mon_breakpoint_switch_checkpoint(e_OFF, (yyvsp[-1].i)); }
    break;

  case 101:
#line 393 "mon_parse.y"
    { mon_breakpoint_set_ignore_count((yyvsp[-1].i), -1); }
    break;

  case 102:
#line 395 "mon_parse.y"
    { mon_breakpoint_set_ignore_count((yyvsp[-3].i), (yyvsp[-1].i)); }
    break;

  case 103:
#line 397 "mon_parse.y"
    { mon_breakpoint_delete_checkpoint((yyvsp[-1].i)); }
    break;

  case 104:
#line 399 "mon_parse.y"
    { mon_breakpoint_delete_checkpoint(-1); }
    break;

  case 105:
#line 401 "mon_parse.y"
    { mon_breakpoint_set_checkpoint_condition((yyvsp[-3].i), (yyvsp[-1].cond_node)); }
    break;

  case 106:
#line 403 "mon_parse.y"
    { mon_breakpoint_set_checkpoint_command((yyvsp[-3].i), (yyvsp[-1].str)); }
    break;

  case 107:
#line 405 "mon_parse.y"
    { return ERR_EXPECT_STRING; }
    break;

  case 108:
#line 409 "mon_parse.y"
    { sidefx = (((yyvsp[-1].action) == e_TOGGLE) ? (sidefx ^ 1) : (yyvsp[-1].action)); }
    break;

  case 109:
#line 411 "mon_parse.y"
    {
                         mon_out("I/O side effects are %s\n",
                                   sidefx ? "enabled" : "disabled");
                     }
    break;

  case 110:
#line 416 "mon_parse.y"
    { default_radix = (yyvsp[-1].rt); }
    break;

  case 111:
#line 418 "mon_parse.y"
    {
                         const char *p;

                         if (default_radix == e_hexadecimal)
                             p = "Hexadecimal";
                         else if (default_radix == e_decimal)
                             p = "Decimal";
                         else if (default_radix == e_octal)
                             p = "Octal";
                         else if (default_radix == e_binary)
                             p = "Binary";
                         else
                             p = "Unknown";

                         mon_out("Default radix is %s\n", p);
                     }
    break;

  case 112:
#line 436 "mon_parse.y"
    {
                         mon_out("Setting default device to `%s'\n",
                         _mon_space_strings[(int) (yyvsp[-1].i)]); default_memspace = (yyvsp[-1].i);
                     }
    break;

  case 113:
#line 441 "mon_parse.y"
    { mon_quit(); YYACCEPT; }
    break;

  case 114:
#line 443 "mon_parse.y"
    { exit_mon = 1; YYACCEPT; }
    break;

  case 115:
#line 447 "mon_parse.y"
    { mon_drive_execute_disk_cmd((yyvsp[-1].str)); }
    break;

  case 116:
#line 449 "mon_parse.y"
    { mon_out("\t%d\n",(yyvsp[-1].i)); }
    break;

  case 117:
#line 451 "mon_parse.y"
    { mon_command_print_help(NULL); }
    break;

  case 118:
#line 453 "mon_parse.y"
    { mon_command_print_help((yyvsp[-1].str)); }
    break;

  case 119:
#line 455 "mon_parse.y"
    { printf("SYSTEM COMMAND: %s\n",(yyvsp[-1].str)); }
    break;

  case 120:
#line 457 "mon_parse.y"
    { mon_print_convert((yyvsp[-1].i)); }
    break;

  case 121:
#line 459 "mon_parse.y"
    { mon_change_dir((yyvsp[-1].str)); }
    break;

  case 122:
#line 461 "mon_parse.y"
    { mon_show_pwd(); }
    break;

  case 123:
#line 463 "mon_parse.y"
    { mon_show_dir((yyvsp[-1].str)); }
    break;

  case 124:
#line 465 "mon_parse.y"
    { mon_keyboard_feed((yyvsp[-1].str)); }
    break;

  case 125:
#line 469 "mon_parse.y"
    { mon_file_load((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].a), FALSE); }
    break;

  case 126:
#line 471 "mon_parse.y"
    { mon_file_load((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].a), TRUE); }
    break;

  case 127:
#line 473 "mon_parse.y"
    { mon_file_save((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], FALSE); }
    break;

  case 128:
#line 475 "mon_parse.y"
    { return ERR_EXPECT_DEVICE_NUM; }
    break;

  case 129:
#line 477 "mon_parse.y"
    { return ERR_EXPECT_ADDRESS; }
    break;

  case 130:
#line 479 "mon_parse.y"
    { mon_file_save((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], TRUE); }
    break;

  case 131:
#line 481 "mon_parse.y"
    { return ERR_EXPECT_ADDRESS; }
    break;

  case 132:
#line 483 "mon_parse.y"
    { mon_file_verify((yyvsp[-3].str),(yyvsp[-2].i),(yyvsp[-1].a)); }
    break;

  case 133:
#line 485 "mon_parse.y"
    { return ERR_EXPECT_ADDRESS; }
    break;

  case 134:
#line 487 "mon_parse.y"
    { mon_drive_block_cmd(0,(yyvsp[-3].i),(yyvsp[-2].i),(yyvsp[-1].a)); }
    break;

  case 135:
#line 489 "mon_parse.y"
    { mon_drive_block_cmd(1,(yyvsp[-3].i),(yyvsp[-2].i),(yyvsp[-1].a)); }
    break;

  case 136:
#line 491 "mon_parse.y"
    { mon_attach((yyvsp[-2].str),(yyvsp[-1].i)); }
    break;

  case 137:
#line 493 "mon_parse.y"
    { mon_detach((yyvsp[-1].i)); }
    break;

  case 138:
#line 497 "mon_parse.y"
    { mon_record_commands((yyvsp[-1].str)); }
    break;

  case 139:
#line 499 "mon_parse.y"
    { mon_end_recording(); }
    break;

  case 140:
#line 501 "mon_parse.y"
    { playback=TRUE; playback_name = (yyvsp[-1].str); }
    break;

  case 141:
#line 505 "mon_parse.y"
    { mon_memory_fill((yyvsp[-2].a), BAD_ADDR, (unsigned char *)(yyvsp[-1].str)); }
    break;

  case 142:
#line 507 "mon_parse.y"
    { printf("Not yet.\n"); }
    break;

  case 143:
#line 510 "mon_parse.y"
    { (yyval.str) = (yyvsp[0].str); }
    break;

  case 144:
#line 513 "mon_parse.y"
    { (yyval.str) = (yyvsp[0].str); }
    break;

  case 145:
#line 514 "mon_parse.y"
    { (yyval.str) = NULL; }
    break;

  case 147:
#line 518 "mon_parse.y"
    { return ERR_EXPECT_FILENAME; }
    break;

  case 149:
#line 522 "mon_parse.y"
    { return ERR_EXPECT_DEVICE_NUM; }
    break;

  case 150:
#line 525 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 151:
#line 526 "mon_parse.y"
    { (yyval.i) = e_load_store; }
    break;

  case 152:
#line 529 "mon_parse.y"
    { (yyval.i) = new_reg(default_memspace, (yyvsp[0].reg)); }
    break;

  case 153:
#line 530 "mon_parse.y"
    { (yyval.i) = new_reg((yyvsp[-1].i), (yyvsp[0].reg)); }
    break;

  case 156:
#line 538 "mon_parse.y"
    { (monitor_cpu_type.mon_register_set_val)(reg_memspace((yyvsp[-2].i)), reg_regid((yyvsp[-2].i)), (WORD) (yyvsp[0].i)); }
    break;

  case 157:
#line 541 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 158:
#line 542 "mon_parse.y"
    { return ERR_EXPECT_BRKNUM; }
    break;

  case 160:
#line 546 "mon_parse.y"
    { (yyval.range)[0] = (yyvsp[0].a); (yyval.range)[1] = BAD_ADDR; }
    break;

  case 161:
#line 549 "mon_parse.y"
    { (yyval.range)[0] = (yyvsp[-2].a); (yyval.range)[1] = (yyvsp[0].a); }
    break;

  case 162:
#line 551 "mon_parse.y"
    { if (resolve_range(e_default_space, (yyval.range), (yyvsp[0].str))) return ERR_ADDR_TOO_BIG; }
    break;

  case 163:
#line 553 "mon_parse.y"
    { if (resolve_range((yyvsp[-2].i), (yyval.range), (yyvsp[0].str))) return ERR_ADDR_TOO_BIG; }
    break;

  case 164:
#line 556 "mon_parse.y"
    { (yyval.a) = (yyvsp[0].a); }
    break;

  case 165:
#line 557 "mon_parse.y"
    { (yyval.a) = BAD_ADDR; }
    break;

  case 166:
#line 561 "mon_parse.y"
    {
             (yyval.a) = new_addr(e_default_space,(yyvsp[0].i));
             if (opt_asm) new_cmd = asm_mode = 1; 
         }
    break;

  case 167:
#line 566 "mon_parse.y"
    {
             (yyval.a) = new_addr((yyvsp[-2].i), (yyvsp[0].i));
             if (opt_asm) new_cmd = asm_mode = 1; 
         }
    break;

  case 168:
#line 571 "mon_parse.y"
    {
             temp = mon_symbol_table_lookup_addr(e_default_space, (yyvsp[0].str));
             if (temp >= 0)
                 (yyval.a) = new_addr(e_default_space, temp);
             else
                 return ERR_UNDEFINED_LABEL;
         }
    break;

  case 171:
#line 584 "mon_parse.y"
    { (yyval.i) = e_comp_space; }
    break;

  case 172:
#line 585 "mon_parse.y"
    { (yyval.i) = e_disk8_space; }
    break;

  case 173:
#line 586 "mon_parse.y"
    { (yyval.i) = e_disk9_space; }
    break;

  case 174:
#line 587 "mon_parse.y"
    { (yyval.i) = e_disk10_space; }
    break;

  case 175:
#line 588 "mon_parse.y"
    { (yyval.i) = e_disk11_space; }
    break;

  case 176:
#line 591 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); if (!CHECK_ADDR((yyvsp[0].i))) return ERR_ADDR_TOO_BIG; }
    break;

  case 177:
#line 593 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 178:
#line 595 "mon_parse.y"
    { (yyval.i) = (yyvsp[-2].i) + (yyvsp[0].i); }
    break;

  case 179:
#line 596 "mon_parse.y"
    { (yyval.i) = (yyvsp[-2].i) - (yyvsp[0].i); }
    break;

  case 180:
#line 597 "mon_parse.y"
    { (yyval.i) = (yyvsp[-2].i) * (yyvsp[0].i); }
    break;

  case 181:
#line 598 "mon_parse.y"
    { (yyval.i) = ((yyvsp[0].i)) ? ((yyvsp[-2].i) / (yyvsp[0].i)) : 1; }
    break;

  case 182:
#line 599 "mon_parse.y"
    { (yyval.i) = (yyvsp[-1].i); }
    break;

  case 183:
#line 600 "mon_parse.y"
    { return ERR_MISSING_CLOSE_PAREN; }
    break;

  case 184:
#line 601 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 185:
#line 605 "mon_parse.y"
    {
               (yyval.cond_node) = new_cond; (yyval.cond_node)->is_parenthized = FALSE;
               (yyval.cond_node)->child1 = (yyvsp[-2].cond_node); (yyval.cond_node)->child2 = (yyvsp[0].cond_node); (yyval.cond_node)->operation = (yyvsp[-1].cond_op);
           }
    break;

  case 186:
#line 610 "mon_parse.y"
    { return ERR_INCOMPLETE_COMPARE_OP; }
    break;

  case 187:
#line 612 "mon_parse.y"
    { (yyval.cond_node) = (yyvsp[-1].cond_node); (yyval.cond_node)->is_parenthized = TRUE; }
    break;

  case 188:
#line 614 "mon_parse.y"
    { return ERR_MISSING_CLOSE_PAREN; }
    break;

  case 189:
#line 616 "mon_parse.y"
    { (yyval.cond_node) = (yyvsp[0].cond_node); }
    break;

  case 190:
#line 619 "mon_parse.y"
    { (yyval.cond_node) = new_cond;
                            (yyval.cond_node)->operation = e_INV;
                            (yyval.cond_node)->is_parenthized = FALSE;
                            (yyval.cond_node)->reg_num = (yyvsp[0].i); (yyval.cond_node)->is_reg = TRUE;
                            (yyval.cond_node)->child1 = NULL; (yyval.cond_node)->child2 = NULL;
                          }
    break;

  case 191:
#line 625 "mon_parse.y"
    { (yyval.cond_node) = new_cond;
                            (yyval.cond_node)->operation = e_INV;
                            (yyval.cond_node)->is_parenthized = FALSE;
                            (yyval.cond_node)->value = (yyvsp[0].i); (yyval.cond_node)->is_reg = FALSE;
                            (yyval.cond_node)->child1 = NULL; (yyval.cond_node)->child2 = NULL;
                          }
    break;

  case 194:
#line 637 "mon_parse.y"
    { mon_add_number_to_buffer((yyvsp[0].i)); }
    break;

  case 195:
#line 638 "mon_parse.y"
    { mon_add_string_to_buffer((yyvsp[0].str)); }
    break;

  case 198:
#line 645 "mon_parse.y"
    { mon_add_number_to_buffer((yyvsp[0].i)); }
    break;

  case 199:
#line 646 "mon_parse.y"
    { mon_add_number_masked_to_buffer((yyvsp[0].i), 0x00); }
    break;

  case 200:
#line 647 "mon_parse.y"
    { mon_add_string_to_buffer((yyvsp[0].str)); }
    break;

  case 201:
#line 650 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 202:
#line 651 "mon_parse.y"
    { (yyval.i) = (monitor_cpu_type.mon_register_get_val)(reg_memspace((yyvsp[0].i)), reg_regid((yyvsp[0].i))); }
    break;

  case 203:
#line 654 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 204:
#line 655 "mon_parse.y"
    { (yyval.i) = strtol((yyvsp[0].str), NULL, 10); }
    break;

  case 205:
#line 656 "mon_parse.y"
    { (yyval.i) = strtol((yyvsp[0].str), NULL, 10); }
    break;

  case 206:
#line 657 "mon_parse.y"
    { (yyval.i) = strtol((yyvsp[0].str), NULL, 10); }
    break;

  case 207:
#line 660 "mon_parse.y"
    { (yyval.i) = resolve_datatype(B_NUMBER,(yyvsp[0].str)); }
    break;

  case 208:
#line 661 "mon_parse.y"
    { (yyval.i) = resolve_datatype(O_NUMBER,(yyvsp[0].str)); }
    break;

  case 209:
#line 662 "mon_parse.y"
    { (yyval.i) = resolve_datatype(D_NUMBER,(yyvsp[0].str)); }
    break;

  case 210:
#line 665 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 211:
#line 666 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 212:
#line 667 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 213:
#line 668 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 214:
#line 669 "mon_parse.y"
    { (yyval.i) = (yyvsp[0].i); }
    break;

  case 218:
#line 677 "mon_parse.y"
    { (yyval.i) = 0;
                                                if ((yyvsp[-1].str)) {
                                                    (monitor_cpu_type.mon_assemble_instr)((yyvsp[-1].str), (yyvsp[0].i));
                                                } else {
                                                    new_cmd = 1;
                                                    asm_mode = 0;
                                                }
                                                opt_asm = 0;
                                              }
    break;

  case 220:
#line 688 "mon_parse.y"
    { asm_mode = 0; }
    break;

  case 221:
#line 691 "mon_parse.y"
    { if ((yyvsp[0].i) > 0xff)
                          (yyval.i) = join_ints(ASM_ADDR_MODE_IMMEDIATE_16,(yyvsp[0].i));
                        else
                          (yyval.i) = join_ints(ASM_ADDR_MODE_IMMEDIATE,(yyvsp[0].i)); }
    break;

  case 222:
#line 695 "mon_parse.y"
    { if ((yyvsp[0].i) < 0x100)
               (yyval.i) = join_ints(ASM_ADDR_MODE_ZERO_PAGE,(yyvsp[0].i));
             else
               (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE,(yyvsp[0].i));
           }
    break;

  case 223:
#line 700 "mon_parse.y"
    { if ((yyvsp[-2].i) < 0x100)
                            (yyval.i) = join_ints(ASM_ADDR_MODE_ZERO_PAGE_X,(yyvsp[-2].i));
                          else
                            (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_X,(yyvsp[-2].i));
                        }
    break;

  case 224:
#line 705 "mon_parse.y"
    { if ((yyvsp[-2].i) < 0x100)
                            (yyval.i) = join_ints(ASM_ADDR_MODE_ZERO_PAGE_Y,(yyvsp[-2].i));
                          else
                            (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_Y,(yyvsp[-2].i));
                        }
    break;

  case 225:
#line 711 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ABS_INDIRECT,(yyvsp[-1].i)); }
    break;

  case 226:
#line 713 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_INDIRECT_X,(yyvsp[-3].i)); }
    break;

  case 227:
#line 715 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_INDIRECT_Y,(yyvsp[-3].i)); }
    break;

  case 228:
#line 716 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_BC,0); }
    break;

  case 229:
#line 717 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_DE,0); }
    break;

  case 230:
#line 718 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_HL,0); }
    break;

  case 231:
#line 719 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_IX,0); }
    break;

  case 232:
#line 720 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_IY,0); }
    break;

  case 233:
#line 721 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IND_SP,0); }
    break;

  case 234:
#line 723 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_A,(yyvsp[-3].i)); }
    break;

  case 235:
#line 725 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_HL,(yyvsp[-3].i)); }
    break;

  case 236:
#line 727 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_IX,(yyvsp[-3].i)); }
    break;

  case 237:
#line 729 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ABSOLUTE_IY,(yyvsp[-3].i)); }
    break;

  case 238:
#line 730 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_IMPLIED,0); }
    break;

  case 239:
#line 731 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_ACCUMULATOR,0); }
    break;

  case 240:
#line 732 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_B,0); }
    break;

  case 241:
#line 733 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_C,0); }
    break;

  case 242:
#line 734 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_D,0); }
    break;

  case 243:
#line 735 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_E,0); }
    break;

  case 244:
#line 736 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_H,0); }
    break;

  case 245:
#line 737 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IXH,0); }
    break;

  case 246:
#line 738 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IYH,0); }
    break;

  case 247:
#line 739 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_L,0); }
    break;

  case 248:
#line 740 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IXL,0); }
    break;

  case 249:
#line 741 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IYL,0); }
    break;

  case 250:
#line 742 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_AF,0); }
    break;

  case 251:
#line 743 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_BC,0); }
    break;

  case 252:
#line 744 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_DE,0); }
    break;

  case 253:
#line 745 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_HL,0); }
    break;

  case 254:
#line 746 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IX,0); }
    break;

  case 255:
#line 747 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_IY,0); }
    break;

  case 256:
#line 748 "mon_parse.y"
    { (yyval.i) = join_ints(ASM_ADDR_MODE_REG_SP,0); }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 3328 "mon_parse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 752 "mon_parse.y"


void parse_and_execute_line(char *input)
{
   char *temp_buf;
   int i, rc;

   temp_buf = (char *)lib_malloc(strlen(input) + 3);
   strcpy(temp_buf,input);
   i = strlen(input);
   temp_buf[i++] = '\n';
   temp_buf[i++] = '\0';
   temp_buf[i++] = '\0';

   make_buffer(temp_buf);
   if ( (rc =yyparse()) != 0) {
       mon_out("ERROR -- ");
       switch(rc) {
         case ERR_BAD_CMD:
           mon_out("Bad command:\n");
           break;
         case ERR_RANGE_BAD_START:
           mon_out("Bad first address in range:\n");
           break;
         case ERR_RANGE_BAD_END:
           mon_out("Bad second address in range:\n");
           break;
         case ERR_EXPECT_BRKNUM:
           mon_out("Checkpoint number expected:\n");
           break;
         case ERR_EXPECT_END_CMD:
           mon_out("Unexpected token:\n");
           break;
         case ERR_MISSING_CLOSE_PAREN:
           mon_out("')' expected:\n");
           break;
         case ERR_INCOMPLETE_COMPARE_OP:
           mon_out("Compare operation missing an operand:\n");
           break;
         case ERR_EXPECT_FILENAME:
           mon_out("Expecting a filename:\n");
           break;
         case ERR_ADDR_TOO_BIG:
           mon_out("Address too large:\n");
           break;
         case ERR_IMM_TOO_BIG:
           mon_out("Immediate argument too large:\n");
           break;
         case ERR_EXPECT_STRING:
           mon_out("Expecting a string.\n");
           break;
         case ERR_UNDEFINED_LABEL:
           mon_out("Found an undefined label.\n");
           break;
         case ERR_EXPECT_DEVICE_NUM:
           mon_out("Expecting a device number.\n");
           break;
         case ERR_EXPECT_ADDRESS:
           mon_out("Expecting an address.\n");
           break;
         case ERR_ILLEGAL_INPUT:
         default:
           mon_out("Wrong syntax:\n");
       }
       mon_out("  %s\n", input);
       for (i = 0; i < last_len; i++)
           mon_out(" ");
       mon_out("  ^\n");
       asm_mode = 0;
       new_cmd = 1;
   }
   free_buffer();
}

static int yyerror(char *s)
{
   fprintf(stderr, "ERR:%s\n", s);
   return 0;
}

static int resolve_datatype(unsigned guess_type, const char *num)
{
   /* FIXME: Handle cases when default type is non-numerical */
   if (default_radix == e_hexadecimal) {
       return strtol(num, NULL, 16);
   }

   if ((guess_type == D_NUMBER) || (default_radix == e_decimal)) {
       return strtol(num, NULL, 10);
   }

   if ((guess_type == O_NUMBER) || (default_radix == e_octal)) {
       return strtol(num, NULL, 8);
   }

   return strtol(num, NULL, 2);
}

/*
 * Resolve a character sequence containing 8 hex digits like "08001000". 
 * This could be a lazy version of "0800 1000". If the default radix is not
 * hexadecimal, we handle it like a ordinary number, in the latter case there
 * is only one number in the range.
 */
static int resolve_range(enum t_memspace memspace, MON_ADDR range[2], 
                         const char *num)
{
    char start[5];
    char end[5];
    long sa;

    range[1] = BAD_ADDR;

    switch (default_radix)
    {
    case e_hexadecimal:
        /* checked twice, but as the code must have exactly 8 digits: */
        if (strlen(num) == 8) {
            memcpy(start, num, 4);
            start[4] = '\0';
            memcpy(end, num + 4, 4);
            end[4] = '\0';
            sa = strtol(start, NULL, 16);
            range[1] = new_addr(memspace, strtol(end, NULL, 16));
        }
        else
            sa = strtol(num, NULL, 16);
        break;

    case e_decimal:
       sa = strtol(num, NULL, 10);
       break;

    case e_octal:
       sa = strtol(num, NULL, 8);
       break;

    default:
       sa = strtol(num, NULL, 2);
    }

    if (!CHECK_ADDR(sa))
        return ERR_ADDR_TOO_BIG;

    range[0] = new_addr(memspace, sa);
    return 0;
}

/* If we want 'quit' for OS/2 I couldn't leave the emulator by calling exit(0)
   So I decided to skip this (I think it's unnecessary for OS/2 */
static void mon_quit(void)
{
#ifdef OS2
    /* same as "quit" */
    exit_mon = 1; 
#else
    exit_mon = 2;
#endif
}


